#ifndef _hashtable_h
#define _hashtable_h

#define HASHTABLE_STRING2(X)		#X
#define HASHTABLE_STRING(X)		HASHTABLE_STRING2(X)
#define HASHTABLE_CONCAT2(X, Y)		X##_##Y
#define HASHTABLE_CONCAT(X, Y)		HASHTABLE_CONCAT2(X, Y)
#define HASHTABLE(X)			HASHTABLE_CONCAT(HASHTABLE_NAME,X)

#if !defined(HASHTABLE_NAME)
# define HASHTABLE_NAME			hashtable
# define HASHTABLE_NAME_DEFINED
#endif

#if !defined(HASHTABLE_ENTRY_NAME)
# define HASHTABLE_ENTRY_NAME		HASHTABLE(entry)
# define HASHTABLE_ENTRY_NAME_DEFINED
#endif

#ifndef HASHTABLE_KEY_T
# define HASHTABLE_KEY_T		char *
# define HASHTABLE_KEY_T_DEFINED
#endif

#if !defined(HASHTABLE_T)
# define HASHTABLE_T			struct HASHTABLE_NAME
# define HASHTABLE_T_DEFINED
#endif

#if !defined(HASHTABLE_ENTRY_T)
# define HASHTABLE_ENTRY_T		struct HASHTABLE_ENTRY_NAME
# define HASHTABLE_ENTRY_T_DEFINED
  HASHTABLE_ENTRY_T
  {
# if defined(HASHTABLE_ENTRY_MEMBERS)
      HASHTABLE_ENTRY_MEMBERS
# endif
      HASHTABLE_KEY_T	 hashtable_entry_key;
      unsigned		 hashtable_entry_length;
      HASHTABLE_ENTRY_T	*hashtable_entry_next;
  };
#endif

HASHTABLE_T
{
#if defined(HASHTABLE_MEMBERS)
    HASHTABLE_MEMBERS
#endif
    unsigned		  hashtable_capacity;
    unsigned		  hashtable_lastfree;
    unsigned		  hashtable_size;
    unsigned		  hashtable_tally;
    HASHTABLE_ENTRY_T	**hashtable_entries;
};

HASHTABLE_T       *HASHTABLE(initialise)(HASHTABLE_T *h, unsigned hashtable_capacity);
HASHTABLE_T       *HASHTABLE(new)	(unsigned hashtable_capacity);
HASHTABLE_T       *HASHTABLE(release)	(HASHTABLE_T *h);
void               HASHTABLE(delete)	(HASHTABLE_T *h);
HASHTABLE_ENTRY_T *HASHTABLE(insert)	(HASHTABLE_T *t, HASHTABLE_KEY_T key, unsigned l);
HASHTABLE_ENTRY_T *HASHTABLE(find)	(HASHTABLE_T *t, HASHTABLE_KEY_T key, unsigned l);

#if !defined(HASHTABLE_KEEP_DEFINITIONS)
# undef HASHTABLE_STRING2
# undef HASHTABLE_STRING
# undef HASHTABLE_CONCAT2
# undef HASHTABLE_CONCAT
# undef HASHTABLE
# if defined(HASHTABLE_NAME_DEFINED)
#   undef HASHTABLE_NAME
#   undef HASHTABLE_NAME_DEFINED
# endif
# if defined(HASHTABLE_ENTRY_NAME_DEFINED)
#   undef HASHTABLE_ENTRY_NAME
#   undef HASHTABLE_ENTRY_NAME_DEFINED
# endif
# if defined(HASHTABLE_KEY_T_DEFINED)
#   undef HASHTABLE_KEY_T
#   undef HASHTABLE_KEY_T_DEFINED
# endif
# if defined(HASHTABLE_T_DEFINED)
#   undef HASHTABLE_T
#   undef HASHTABLE_T_DEFINED
# endif
# if defined(HASHTABLE_ENTRY_T_DEFINED)
#   undef HASHTABLE_ENTRY_T
#   undef HASHTABLE_ENTRY_T_DEFINED
# endif
#endif

#endif /* _hashtable_h */
